public class Pole
{
	private int mX;
	private int mY;
	private Agent mAgent = null;
	private int mWart;
	private Srodowisko mSrodowisko;
	
	public Pole(Srodowisko s, int x, int y, int wart)
	{
		mSrodowisko = s;
		mX = x;
		mY = y;
		mWart = wart;
	}
	
	private Pole getPole(int kierunek)
	{
		int x = mX, y = mY;
		switch(kierunek)
		{
			case 0: return this;
			case 1: y--; break;
			case 2: x++; break;
			case 3: y++; break;
			case 4: x--; break;
			default: return null;
		}
		
		return mSrodowisko.getPole(x, y);
	}
	
	/* Zwraca:
	   -1      jeli docelowe pole jest zajete lub nie istnieje
	   wartosc jesli docelowe pole jest puste
	*/
	public int percept(int kierunek)
	{		
		Pole p = getPole(kierunek);
		if ((p == null) || (p.getAgent() != null))
			return -1;
		return p.getWart();		
	}
	
	public boolean move(int kierunek)
	{
		Pole p = getPole(kierunek);
		if ((kierunek == 0) || (p == null) || (p.getAgent() != null))
			return false;
		
		p.setAgent(mAgent);		
		mAgent = null;	
		return true;
	}
	
	public Agent getAgent()
	{
		return mAgent;
	}
	
	public void setAgent(Agent a)
	{
		mAgent = a;
		a.setPole(this);
	}
	
	public int getWart()
	{
		return mWart;
	}
}
